VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6465
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   10665
   LinkTopic       =   "Form1"
   ScaleHeight     =   6465
   ScaleWidth      =   10665
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command2 
      Caption         =   "Quit AP"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   9240
      TabIndex        =   3
      Top             =   5280
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Execute"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   9240
      TabIndex        =   2
      Top             =   4200
      Width           =   1215
   End
   Begin MSFlexGridLib.MSFlexGrid MSFlexGrid2 
      Height          =   2895
      Left            =   240
      TabIndex        =   1
      Top             =   3360
      Width           =   8775
      _ExtentX        =   15478
      _ExtentY        =   5106
      _Version        =   393216
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin MSFlexGridLib.MSFlexGrid MSFlexGrid1 
      Height          =   2895
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   8775
      _ExtentX        =   15478
      _ExtentY        =   5106
      _Version        =   393216
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   9240
      TabIndex        =   5
      Top             =   3480
      Width           =   1215
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   9240
      TabIndex        =   4
      Top             =   360
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub Command1_Click()

  Const MAX_CNT = 200
  Dim stat  As ViSession
  Dim dfltRM As ViSession
  Dim sesn1 As Long  ' session for device-1
  Dim sesn2 As Long  ' session for device-2
 ' Dim retCount As String * MAX_CNT
 ' Dim Buffer As ViStatus
  Dim wcnt As Long
  Dim rcnt As Long
  Dim findList As Long
  Dim instrs As Long
  Dim instrDesc As String * 256
  Dim readinstr As String * 64
  Dim rr As String * 320        ' readings (20) * bytes (16)
  Dim ret As String * 16
  Dim i, j, k As Integer
  Dim row, pos As Integer
  Dim scard(2) As Integer
    
  ' Begin by initializing the system
  stat = viOpenDefaultRM(dfltRM)
  If (stat < VI_SUCCESS) Then
    Rem Error initializing VISA...exiting
    MsgBox "Initializing VISA library error.", vbExclamation + vbOKOnly, "M3500A scan card test"
    Exit Sub
  End If

  ' Find resource USB instrument  VID:0x164E  PID:0x0DAD
  stat = viFindRsrc(dfltRM, "USB[0-9]*::0x164E::0x0DAD::?*INSTR", findList, instrs, instrDesc)

  If instrs <= 0 Then
    Command1.Enabled = False
    Command2.SetFocus
    stat = viClose(dfltRM)
    MsgBox "M3500A device not found.", vbExclamation + vbOKOnly, "M3500A scan card test"
    Exit Sub
  End If

  ' Setting the device-1 scan card status
  stat = viOpen(dfltRM, instrDesc, VI_NULL, VI_NULL, sesn1)
  ' Set the timeout for message-based communication
  stat = viSetAttribute(sesn1, VI_ATTR_TMO_VALUE, 35000)
  ' Reset and Clear the device for identification
  stat = viWrite(sesn1, "*RST" & vbLf, 5, wcnt)
  stat = viWrite(sesn1, "*CLS" & vbLf, 5, wcnt)
  stat = viWrite(sesn1, "Rout:state?" & vbLf, 12, wcnt)
  Sleep (50)
  stat = viRead(sesn1, readinstr, MAX_CNT, rcnt)
  If (Left(readinstr, 1) = "1") Then
    scard(1) = 1
    stat = viWrite(sesn1, "CONF:FRES 100000" & vbLf, 17, wcnt)
    Sleep (50)
    ' set the scan reading count = 20
    stat = viWrite(sesn1, "Rout:scan:count 20" & vbLf, 19, wcnt)
    Sleep (50)
    stat = viWrite(sesn1, "Rout:scan:timer 0.5" & vbLf, 20, wcnt)
    Sleep (50)
    ' Set the Scanner card the channels scan function 4W resistance
    For k = 1 To 5
      stat = viWrite(sesn1, "rout:scan:func " & Trim(Str(k)) & "," & Chr(34) & "FRES" & Chr(34) & vbLf, 24, wcnt)
    Next k
    stat = viWrite(sesn1, "Rout:scan" & vbLf, 10, wcnt)
  Else
    scard(1) = 0
  End If

  ' Setting the device-2 scan card status
  If (instrs > 1) Then
    'find next desriptor
    stat = viFindNext(findList, instrDesc)
    If (stat < VI_SUCCESS) Then
      scard(2) = 0
    Else
      stat = viOpen(dfltRM, instrDesc, VI_NULL, VI_NULL, sesn2)
      ' Set the timeout for message-based communication
      stat = viSetAttribute(sesn2, VI_ATTR_TMO_VALUE, 35000)
      ' Reset and Clear the device for identification
      stat = viWrite(sesn2, "*RST" & vbLf, 5, wcnt)
      stat = viWrite(sesn2, "*CLS" & vbLf, 5, wcnt)
      stat = viWrite(sesn2, "Rout:state?" & vbLf, 12, wcnt)
      Sleep (50)
      stat = viRead(sesn2, readinstr, MAX_CNT, rcnt)
      If (Left(readinstr, 1) = "1") Then
        scard(2) = 1
        stat = viWrite(sesn2, "CONF:FRES 100000" & vbLf, 17, wcnt)
        Sleep (50)
        ' set the scan reading count = 20
        stat = viWrite(sesn2, "Rout:scan:count 20" & vbLf, 19, wcnt)
        Sleep (50)
        stat = viWrite(sesn2, "Rout:scan:timer 0.5" & vbLf, 20, wcnt)
        Sleep (50)
        ' Set the Scanner card the channels scan function 4W resistance
        For k = 1 To 5
          stat = viWrite(sesn2, "rout:scan:func " & Trim(Str(k)) & "," & Chr(34) & "FRES" & Chr(34) & vbLf, 24, wcnt)
        Next k
        stat = viWrite(sesn2, "Rout:scan" & vbLf, 10, wcnt)
      Else
        scard(2) = 0
      End If
    End If
  Else
    scard(2) = 0
  End If

  i = 0
  j = 0
  If scard(1) = 1 Then
    i = 1
  End If
  If scard(2) = 1 Then
    j = 1
  End If
  
  ' Check the M3500A scan state
  Do While (i + j)
    DoEvents
    If i = 1 Then
      stat = viWrite(sesn1, "Rout:scan:state?" & vbLf, 17, wcnt)
      Sleep (50)
      readinstr = ""
      stat = viRead(sesn1, readinstr, MAX_CNT, rcnt)
      k = Val(readinstr)
      Label1.Caption = Str(k) & " / 20"
      If k >= 20 Then
        i = 0
      End If
    End If
    If j = 1 Then
      stat = viWrite(sesn2, "Rout:scan:state?" & vbLf, 17, wcnt)
      Sleep (50)
      readinstr = ""
      stat = viRead(sesn2, readinstr, MAX_CNT, rcnt)
      k = Val(readinstr)
      Label2.Caption = Str(k) & " / 20"
      If k >= 20 Then
        j = 0
      End If
    End If
    Sleep (500)
  Loop

  ' Fetch the scanned readings
  If scard(1) Then
    stat = viWrite(sesn1, "fetch?" & vbLf, 7, wcnt)
    Sleep (50)
    stat = viRead(sesn1, rr, 320, rcnt)
    row = 1
    pos = 1
    j = 0
    ' Show the readings on the Grid
    Do While (pos < 320)
      MSFlexGrid1.row = row
      MSFlexGrid1.Col = 0
      MSFlexGrid1.Text = row
      For k = 1 To 5
        ret = Mid(rr, pos, pos + 14)
        If Left(ret, 15) = "+9.90000000E+37" Then
          ret = "OVLD"
        End If
        MSFlexGrid1.Col = k
        MSFlexGrid1.Text = ret
        pos = pos + 16
      Next k
      row = row + 1
    Loop
  End If

  If scard(2) Then
    rr = ""
    stat = viWrite(sesn2, "fetch?" & vbLf, 7, wcnt)
    Sleep (50)
    stat = viRead(sesn2, rr, 320, rcnt)
    rr = rr & ","
    row = 1
    pos = 1
    j = 0
    ' Show the readings on the Grid
    Do While (pos < 320)
      MSFlexGrid2.row = row
      MSFlexGrid2.Col = 0
      MSFlexGrid2.Text = row
      For k = 1 To 5
        ret = Mid(rr, pos, pos + 14)
        If Left(ret, 15) = "+9.90000000E+37" Then
          ret = "OVLD"
        End If
        MSFlexGrid2.Col = k
        MSFlexGrid2.Text = ret
        pos = pos + 16
      Next k
      row = row + 1
    Loop
  End If

  ' close the connect device
  For i = 1 To instrs
    stat = viOpen(dfltRM, instrDesc, VI_NULL, VI_NULL, sesn1)
    stat = viWrite(sesn1, "system:local", 12, wcnt)
    stat = viClose(sesn1)
    stat = viFindNext(findList, instrDesc)
    If (stat < VI_SUCCESS) Then
      Exit For
    End If
  Next i
  ' Close the Resource Manager
  stat = viClose(dfltRM)

  MsgBox "End of Job."

End Sub

Private Sub Command2_Click()

  End

End Sub



Private Sub Form_Load()

  Dim i As Integer
  
  MSFlexGrid1.Rows = 9
  MSFlexGrid1.Cols = 6
  MSFlexGrid1.Clear
  
  MSFlexGrid1.row = 0
  MSFlexGrid1.ColWidth(0) = 300
  For i = 1 To 5
    MSFlexGrid1.ColWidth(i) = 1700
    MSFlexGrid1.ColAlignment(i) = 4
    MSFlexGrid1.Col = i
    MSFlexGrid1.Text = "CH" & Str(i) & " (4WR)"
  Next i
  
  MSFlexGrid2.Rows = 9
  MSFlexGrid2.Cols = 6
  MSFlexGrid2.Clear
  
  MSFlexGrid2.row = 0
  MSFlexGrid2.ColWidth(0) = 300
  For i = 1 To 5
    MSFlexGrid2.ColWidth(i) = 1700
    MSFlexGrid2.ColAlignment(i) = 4
    MSFlexGrid2.Col = i
    MSFlexGrid2.Text = "CH" & Str(i) & " (4WR)"
  Next i

End Sub

